<template>
  <div class="input">
    <input
      :class="{ 'input--valid': isValid }"
      ref="input"
      :type="inputType"
      v-bind="$attrs"
      v-on="listeners"
    />
  </div>
</template>

<script>
import { isNumber, numberAllowedKeys } from '../../utils/helpers'

export default {
  inheritAttrs: false,
  props: {
    isValid: {
      type: Boolean,
      default: false
    },
    type: {
      type: String,
      default: 'text'
    }
  },
  computed: {
    listeners() {
      return {
        ...this.$listeners,
        input: e => {
          const value = this.validateValue(e.target.value) ? e.target.value : ''
          return this.$emit('input', value)
        },
        keydown: e => {
          if (!this.validateValue(e.key) && !numberAllowedKeys.includes(e.code)) {
            e.preventDefault()
          }
          this.$emit('keydown', e)
        }
      }
    },
    inputType() {
      return this.type === 'number' ? 'text' : this.type
    }
  },
  methods: {
    validateValue(value) {
      if (this.type === 'number') {
        return isNumber(value)
      }
      return true
    },
    focus() {
      if (this.$refs.input) {
        this.$refs.input.focus()
        if (this.$refs.input.value) {
          this.$refs.input.select()
        }
      }
    }
  }
}
</script>

<style scoped lang="scss">
input {
  border: 0;
  border-bottom: 2px solid #eee;
  background: none;
  outline: none;
  width: 100%;
  &.input--valid {
    border-color: green;
  }
}
</style>